/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2011-2015 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2011-2015 by FUJI SOFT INCORPORATED, JAPAN
 *  Copyright (C) 2011-2013 by Spansion LLC, USA
 *  Copyright (C) 2011-2015 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2011-2015 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2011-2014 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2011-2015 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2011-2015 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2011-2015 by Witz Corporation
 *  Copyright (C) 2014-2015 by AISIN COMCRUISE Co., Ltd., JAPAN
 *  Copyright (C) 2014-2015 by eSOL Co.,Ltd., JAPAN
 *  Copyright (C) 2014-2015 by SCSK Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: target_hw_counter.c 1801 2015-03-27 06:34:43Z t_ishikawa $
 */

/*
 *		ʲϡɥ󥿥ץΥåȰ¸NIOS2_DEVѡ
 *
 *  Ѥ륿ޡ
 *    ʬޡŪλ֤ꤹθ߻(ͥ)
 *              ȼλ֤Ȥл֤򥫥Ȥ뤳Ȥ
 *              Ūл֤λȤȤ
 *              count mode:count down once
 *
 *    ͥޡ󥿼ʬΥ١ޤ¸
 *              (л֤򥫥)
 *              count mode:continuous count down
 *
 *    ޤ嵭Υޤ32bitΥ󥫥󥿥ޤǤ
 *
 *  ˡ
 *
 *   ͥޤϥ桼󥿺2+1ޤǥȤ
 *   ޤȤϢ³ȥ󤷤ơ˸߻
 *   롥ȯɬפʤᡤߤʤ⡼
 *
 *   ʬޤϡλԤᡤߤ⡼ɤư
 *   顼ʤɤλȥޡ1Ǽ߻κ
 *   ͥޤꤹ
 *
 *  ݥȡ
 *   λϡ߻ƶʤᡤͥޤߤƤ
 *
 */
#if defined(TOPPERS_NIOS2_DEV_2S180) || defined(TOPPERS_NIOS2_DEV_DE2_115) || defined(TOPPERS_NIOS2_DEV_DE0_NANO)

#include "Os.h"
#include "prc_sil.h"
#include "target_hw_counter.h"

/* ؿΥץȥ */
static TickType get_curr_time(uint32 irq_no, TickType maxval);
static void init_hwcounter(uint32 irq_no, TickType maxval, TimeType nspertick, TickRefType cycle);
static void start_hwcounter(uint32 irq_no);
static void stop_hwcounter(uint32 irq_no);
static void set_hwcounter(uint32 irq_no, TickType exprtick, TickType maxval);
static TickType get_hwcounter(uint32 irq_no, TickType maxval);
static void cancel_hwcounter(uint32 irq_no);
static void trigger_hwcounter(uint32 irq_no);
static void int_clear_hwcounter(uint32 irq_no);
static void int_cancel_hwcounter(uint32 irq_no);
static void increment_hwcounter(uint32 irq_no);

/*
 *  ϡɥ󥿸ߥƥåͼ
 *  󥫥󥿥ޤΤᡤѴɬ
 */
static TickType
get_curr_time(uint32 irq_no, TickType maxval)
{
	TickType curr_time = 0U;

	/* ʥåץ쥸˽񤭹ͤۡɤ */
	sil_wrw_iop((void *) TIMER_SNAPL(irq_no + 1U), 0x00U);

	/* ޡ饫ͤɤ߹ */
	curr_time = sil_rew_iop((void *) TIMER_SNAPL(irq_no + 1U));
	curr_time |= sil_rew_iop((void *) TIMER_SNAPH(irq_no + 1U)) << 16U;

	/* 󥫥󥿤ΰ١ߥåͤѴ */
	curr_time = maxval - curr_time;

	return(curr_time);
}

/*
 *  ϡɥ󥿤ν
 */
static void
init_hwcounter(uint32 irq_no, TickType maxval, TimeType nspertick, TickRefType cycle)
{
	*cycle = maxval;

	/* ʬ */
	sil_wrw_iop((void *) TIMER_CONTROL(irq_no), TIMER_CONTROL_STOP);
	/* ʬޥॢȥơꥢ */
	sil_wrw_iop((void *) TIMER_STATUS(irq_no), 0x00U);

	/* ͥ */
	sil_wrw_iop((void *) TIMER_CONTROL(irq_no + 1U), TIMER_CONTROL_STOP);
	/* ͥޥॢȥơꥢ */
	sil_wrw_iop((void *) TIMER_STATUS(irq_no + 1U), 0x00U);

	/* ͥޥ󥿡å 16bit */
	sil_wrw_iop((void *) TIMER_PERIODH(irq_no + 1U), (maxval >> 16U));
	/* ͥޥ󥿡å 16bit */
	sil_wrw_iop((void *) TIMER_PERIODL(irq_no + 1U), (maxval & 0xffffU));
}

/*
 *  ϡɥ󥿤γ
 */
static void
start_hwcounter(uint32 irq_no)
{
	/*
	 *  ͥ޳(continuous count down mode)
	 *  ɬפʤᡤߤʤ⡼
	 */
	sil_wrw_iop((void *) TIMER_CONTROL(irq_no + 1U), TIMER_CONTROL_CONT | TIMER_CONTROL_START);
}

/*
 *  ϡɥ󥿤
 */
static void
stop_hwcounter(uint32 irq_no)
{
	/* ʬ */
	sil_wrw_iop((void *) TIMER_CONTROL(irq_no), TIMER_CONTROL_STOP);

	/* ʬޤγ׵Υꥢ */
	sil_wrw_iop((void *) TIMER_STATUS(irq_no), 0x00U);

	/* ͥ */
	sil_wrw_iop((void *) TIMER_CONTROL(irq_no + 1U), TIMER_CONTROL_STOP);

	/* ͥޤγ׵Υꥢ */
	sil_wrw_iop((void *) TIMER_STATUS(irq_no + 1U), 0x00U);
}

/*
 *  ϡɥ󥿤ؤλ֤
 */
static void
set_hwcounter(uint32 irq_no, TickType exprtick, TickType maxval)
{
	TickType	curr_time;
	TickType	value;

	/* ʬޤγ׵Υꥢ */
	sil_wrw_iop((void *) TIMER_STATUS(irq_no), 0x00U);

	/* ߻μ	*/
	curr_time = get_curr_time(irq_no, maxval);

	/* ޤꤹͤ򻻽	*/
	if (exprtick >= curr_time) {
		value = exprtick - curr_time;
	}
	else {
		value = maxval - curr_time + exprtick + 1U;
	}

	/*
	 *  ޤ0x00ꤷȯ塤0ꤷ硤2ܤ
	 *  0x00γߤȯʤΤǡ0x00ͤ0x01ľ
	 *  ޤ˥åȤͤϡԤΥͤ-1ɬפ
	 */
	if (value <= 0x01U) {
		value = 0x01U;
	}
	else {
		value -= 1U;
	}

	/*
	 *  ʬޥ󥿡å 16bit
	 *  աbitꤷʤȡ2ȯǽ
	 */
	sil_wrw_iop((void *) TIMER_PERIODH(irq_no), (value >> 16U));
	/* ʬޥ󥿡å 16bit */
	sil_wrw_iop((void *) TIMER_PERIODL(irq_no), (value & 0xffffU));

	/*
	 *  ʬ޳(count down once mode)
	 *  ɬפΤᡤߥ⡼ɤ
	 */
	sil_wrw_iop((void *) TIMER_CONTROL(irq_no), TIMER_CONTROL_ITO | TIMER_CONTROL_START);
}

/*
 *  ϡɥ󥿤θ߻֤μ
 */
static TickType
get_hwcounter(uint32 irq_no, TickType maxval)
{
	return(get_curr_time(irq_no, maxval));
}

/*
 *  ϡɥ󥿤ꤵ줿λ֤μ
 */
static void
cancel_hwcounter(uint32 irq_no)
{
	/* ʬ */
	sil_wrw_iop((void *) TIMER_CONTROL(irq_no), TIMER_CONTROL_STOP);
}

/*
 *  ϡɥ󥿤ζ׵
 */
static void
trigger_hwcounter(uint32 irq_no)
{
	/* ʬ */
	sil_wrw_iop((void *) TIMER_CONTROL(irq_no), TIMER_CONTROL_STOP);

	/* ʬޤγ׵Υꥢ */
	sil_wrw_iop((void *) TIMER_STATUS(irq_no), 0x00U);

	/* ʬޥ󥿡0x01򥻥åȤ뤳Ȥǡλ */
	sil_wrw_iop((void *) TIMER_PERIODH(irq_no), 0x00U);
	sil_wrw_iop((void *) TIMER_PERIODL(irq_no), 0x01U);

	/* ʬ޳ */
	sil_wrw_iop((void *) TIMER_CONTROL(irq_no), TIMER_CONTROL_ITO | TIMER_CONTROL_START);
}

/*
 *  ׵Υꥢ
 */
static void
int_clear_hwcounter(uint32 irq_no)
{
	/* ʬޤγ׵Υꥢ */
	sil_wrw_iop((void *) TIMER_STATUS(irq_no), 0x00U);
}

/*
 *  ׵Υ󥻥
 *  ڥǥ󥰤Ƥ׵򥭥󥻥
 */
static void
int_cancel_hwcounter(uint32 irq_no)
{
	/* ʬޤγ׵Υꥢ */
	sil_wrw_iop((void *) TIMER_STATUS(irq_no), 0x00U);
}

/*
 *  ϡɥ󥿤Υ󥯥
 */
static void
increment_hwcounter(uint32 irq_no)
{
	/* Nios2åȤ̤ݡ */
	return;
}

/*
 *  MAIN_HW_COUNTER
 */
/* 󥿤κͤ2+1 */
static TickType MAIN_HW_COUNTER_maxval;

/*
 *  ϡɥ󥿤ν
 */
void
init_hwcounter_MAIN_HW_COUNTER(TickType maxval, TimeType nspertick)
{
	init_hwcounter(TIMER_0_IRQ, maxval, nspertick, &MAIN_HW_COUNTER_maxval);
}

/*
 *  ϡɥ󥿤γ
 */
void
start_hwcounter_MAIN_HW_COUNTER(void)
{
	start_hwcounter(TIMER_0_IRQ);
}

/*
 *  ϡɥ󥿤
 */
void
stop_hwcounter_MAIN_HW_COUNTER(void)
{
	stop_hwcounter(TIMER_0_IRQ);
}

/*
 *  ϡɥ󥿤ؤλ֤
 */
void
set_hwcounter_MAIN_HW_COUNTER(TickType exprtick)
{
	set_hwcounter(TIMER_0_IRQ, exprtick, MAIN_HW_COUNTER_maxval);
}

/*
 *  ϡɥ󥿤θ߻֤μ
 */
TickType
get_hwcounter_MAIN_HW_COUNTER(void)
{
	return(get_hwcounter(TIMER_0_IRQ, MAIN_HW_COUNTER_maxval));
}

/*
 *  ϡɥ󥿤ꤵ줿λ֤μ
 */
void
cancel_hwcounter_MAIN_HW_COUNTER(void)
{
	cancel_hwcounter(TIMER_0_IRQ);
}

/*
 *  ϡɥ󥿤ζ׵
 */
void
trigger_hwcounter_MAIN_HW_COUNTER(void)
{
	trigger_hwcounter(TIMER_0_IRQ);
}

/*
 *  ϡɥ󥿤ꤵ줿λ֤μ
 */
void
int_clear_hwcounter_MAIN_HW_COUNTER(void)
{
	int_clear_hwcounter(TIMER_0_IRQ);
}

/*
 *  ϡɥ󥿤ꤵ줿λ֤μ
 */
void
int_cancel_hwcounter_MAIN_HW_COUNTER(void)
{
	int_cancel_hwcounter(TIMER_0_IRQ);
}

/*
 *  ϡɥ󥿤Υ󥯥
 */
void
increment_hwcounter_MAIN_HW_COUNTER(void)
{
	increment_hwcounter(TIMER_0_IRQ);
}

/*
 *  SUB_HW_COUNTER1B
 */
/* 󥿤κͤ2+1 */
static TickType SUB_HW_COUNTER1_maxval;

/*
 *  ϡɥ󥿤ν
 */
void
init_hwcounter_SUB_HW_COUNTER1(TickType maxval, TimeType nspertick)
{
	init_hwcounter(TIMER_2_IRQ, maxval, nspertick, &SUB_HW_COUNTER1_maxval);
}

/*
 *  ϡɥ󥿤γ
 */
void
start_hwcounter_SUB_HW_COUNTER1(void)
{
	start_hwcounter(TIMER_2_IRQ);
}

/*
 *  ϡɥ󥿤
 */
void
stop_hwcounter_SUB_HW_COUNTER1(void)
{
	stop_hwcounter(TIMER_2_IRQ);
}

/*
 *  ϡɥ󥿤ؤλ֤
 */
void
set_hwcounter_SUB_HW_COUNTER1(TickType exprtick)
{
	set_hwcounter(TIMER_2_IRQ, exprtick, SUB_HW_COUNTER1_maxval);
}

/*
 *  ϡɥ󥿤θ߻֤μ
 */
TickType
get_hwcounter_SUB_HW_COUNTER1(void)
{
	return(get_hwcounter(TIMER_2_IRQ, SUB_HW_COUNTER1_maxval));
}

/*
 *  ϡɥ󥿤ꤵ줿λ֤μ
 */
void
cancel_hwcounter_SUB_HW_COUNTER1(void)
{
	cancel_hwcounter(TIMER_2_IRQ);
}

/*
 *  ϡɥ󥿤ζ׵
 */
void
trigger_hwcounter_SUB_HW_COUNTER1(void)
{
	trigger_hwcounter(TIMER_2_IRQ);
}

/*
 *  ϡɥ󥿤ꤵ줿λ֤μ
 */
void
int_clear_hwcounter_SUB_HW_COUNTER1(void)
{
	int_clear_hwcounter(TIMER_2_IRQ);
}

/*
 *  ϡɥ󥿤ꤵ줿λ֤μ
 */
void
int_cancel_hwcounter_SUB_HW_COUNTER1(void)
{
	int_cancel_hwcounter(TIMER_2_IRQ);
}

/*
 *  ϡɥ󥿤Υ󥯥
 */
void
increment_hwcounter_SUB_HW_COUNTER1(void)
{
	increment_hwcounter(TIMER_2_IRQ);
}

/*
 *  SUB_HW_COUNTER2
 */
/* 󥿤κͤ2+1 */
static TickType SUB_HW_COUNTER2_maxval;

/*
 *  ϡɥ󥿤ν
 */
void
init_hwcounter_SUB_HW_COUNTER2(TickType maxval, TimeType nspertick)
{
	init_hwcounter(TIMER_4_IRQ, maxval, nspertick, &SUB_HW_COUNTER2_maxval);
}

/*
 *  ϡɥ󥿤γ
 */
void
start_hwcounter_SUB_HW_COUNTER2(void)
{
	start_hwcounter(TIMER_4_IRQ);
}

/*
 *  ϡɥ󥿤
 */
void
stop_hwcounter_SUB_HW_COUNTER2(void)
{
	stop_hwcounter(TIMER_4_IRQ);
}

/*
 *  ϡɥ󥿤ؤλ֤
 */
void
set_hwcounter_SUB_HW_COUNTER2(TickType exprtick)
{
	set_hwcounter(TIMER_4_IRQ, exprtick, SUB_HW_COUNTER2_maxval);
}

/*
 *  ϡɥ󥿤θ߻֤μ
 */
TickType
get_hwcounter_SUB_HW_COUNTER2(void)
{
	return(get_hwcounter(TIMER_4_IRQ, SUB_HW_COUNTER2_maxval));
}

/*
 *  ϡɥ󥿤ꤵ줿λ֤μ
 */
void
cancel_hwcounter_SUB_HW_COUNTER2(void)
{
	cancel_hwcounter(TIMER_4_IRQ);
}

/*
 *  ϡɥ󥿤ζ׵
 */
void
trigger_hwcounter_SUB_HW_COUNTER2(void)
{
	trigger_hwcounter(TIMER_4_IRQ);
}

/*
 *  ϡɥ󥿤ꤵ줿λ֤μ
 */
void
int_clear_hwcounter_SUB_HW_COUNTER2(void)
{
	int_clear_hwcounter(TIMER_4_IRQ);
}

/*
 *  ϡɥ󥿤ꤵ줿λ֤μ
 */
void
int_cancel_hwcounter_SUB_HW_COUNTER2(void)
{
	int_cancel_hwcounter(TIMER_4_IRQ);
}

/*
 *  ϡɥ󥿤Υ󥯥
 */
void
increment_hwcounter_SUB_HW_COUNTER2(void)
{
	increment_hwcounter(TIMER_4_IRQ);
}

#endif /* defined(TOPPERS_NIOS2_DEV_2S180) || defined(TOPPERS_NIOS2_DEV_DE2_115) */
